/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MOVZ_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MOVZ_S.class,
         "MOVZ_S",
         false,
         new ParamDecls()
             .declareParam("fd", ArgumentMode.OUT, F.INFO)
             .declareParam("fs", ArgumentMode.IN, F.INFO)
             .declareParam("rt", ArgumentMode.IN, R.INFO),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IAddressingMode fd = (IAddressingMode) getArgument("fd", args);
      final IAddressingMode fs = (IAddressingMode) getArgument("fs", args);
      final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);

      return new MOVZ_S(fd, fs, rt);
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode fd;
  private final IAddressingMode fs;
  private final IAddressingMode rt;

  public MOVZ_S(IAddressingMode fd, IAddressingMode fs, IAddressingMode rt) {
    assert F.INFO.isSupported(fd);
    assert F.INFO.isSupported(fs);
    assert R.INFO.isSupported(rt);

    this.fd = fd;
    this.fs = fs;
    this.rt = rt;
  }

  @Override
  public String syntax() {
    return String.format("MOVZ_S %s, %s, %s", fd.syntax(), fs.syntax(), rt.syntax());
  }

  @Override
  public String image() {
    return String.format("01000110000%s%s%s010010", rt.image(), fs.image(), fd.image());
  }

  @Override
  public void action() {
    if (DataEngine.intValue(rt.access().load()) == 0x0)
    {
        fd.access().store(fs.access().load());
    }
  }
}
